# dbt Integration Discovered Resources

## Overview

The dbt integration discovers the following resources:

* dbt project
* dbt Transformation Layer:
  * dbt sources, seeds, models, exposures and snapshots
  * databases, schemas, tables and columns
* dbt Semantic Layer:
  * dbt metrics
  * dbt measures
  * dbt dimensions
  * dbt semantic models
* warehouse resources
  * columns
  * tables
  * schemas
  * databases

## dbt resources properties observed

| property                       | Value                                                                                                                                                    | Applicable to                                                                 |
| ------------------------------ | -------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------------------------------------------------------------------------- |
| name                           | The property stores the name of the dbt resource. In case there is an alias, Euno uses the alias for the "name" property                                 | All dbt resources                                                             |
| description                    | This property stores description of the resource.                                                                                                        | All dbt resources                                                             |
| first\_observed                | This property stores when Euno first observed the resource.                                                                                              | All dbt resources                                                             |
| last\_observed                 | This property stores when Euno last observed the resource.                                                                                               | All dbt resources                                                             |
| type                           | `dbt_source`, `dbt_seed,` `dbt_model`, `dbt_metric`, `dbt_exposure`, `dbt_snapshot`, `dbt_dimension`, `dbt_measure`, `dbt_semantic_model`, `dbt_project` | All dbt resources                                                             |
| is\_external\_package          | The property stores whether the resource is from an external dbt package.                                                                                | dbt sources, dbt seeds, dbt models, dbt semantic models                       |
| package\_name                  | The property stores the name of the package the resource belongs to.                                                                                     | dbt sources, dbt seeds, dbt models, dbt semantic models                       |
| dbt\_materialization\_strategy | The property stores how the model will be materialization data warehouse.                                                                                | dbt models                                                                    |
| source\_path                   | Stores the relative path in the source code that defines this resource                                                                                   | All dbt resources                                                             |
| source\_directory              | Stores the relative directory in the source code that defines this resource                                                                              | All dbt resources                                                             |
| dbt\_project                   | The dbt project the resource is found within.                                                                                                            | All dbt resources                                                             |
| tags                           | The property stores the tags of the resource.                                                                                                            | dbt sources, dbt seeds, dbt models, dbt exposures, dbt snapshots, dbt metrics |
| meta                           | The property stores the meta of the resource.                                                                                                            | dbt sources, dbt seeds, dbt models, dbt exposures, dbt snapshots, dbt metrics |
| database                       | The property stores the database the resource is located in.                                                                                             | dbt sources, dbt seeds, dbt models                                            |
| schema                         | The property stores the schema the resource is located in.                                                                                               | dbt sources, dbt seeds, dbt models                                            |
| unique\_id                     | The dbt unique\_id of the resource                                                                                                                       | dbt sources, dbt seeds, dbt models, dbt semantic models, dbt metrics          |
| defines                        | A list of resources within the database that the dbt resource defines (e.g., tables in the database).                                                    | dbt sources, dbt seeds, dbt models                                            |
| total\_builds\_14d             | The total number of times the dbt model was built in the last 14 days.                                                                                   | dbt models, dbt seeds, dbt snapshots                                          |
| total\_builds\_30d             | The total number of times the dbt model was built in the last 30 days.                                                                                   | dbt models, dbt seeds, dbt snapshots                                          |
| total\_builds\_60d             | The total number of times the dbt model was built in the last 60 days.                                                                                   | dbt models, dbt seeds, dbt snapshots                                          |
| average\_build\_time\_14d      | Average duration of a single build over the last 14 days.                                                                                                | dbt models, dbt\_seeds, dbt snapshots                                         |
| average\_build\_time\_30d      | Average duration of a single build over the last 30 days.                                                                                                | dbt models, dbt\_seeds, dbt snapshots                                         |
| average\_build\_time\_60d      | Average duration of a single build over the last 60 days.                                                                                                | dbt models, dbt\_seeds, dbt snapshots                                         |

## data warehouse resources properties observed

| Property     | Value                                                                                     | Applicable to                   |
| ------------ | ----------------------------------------------------------------------------------------- | ------------------------------- |
| name         | Table name. In the case of using `alias` or `identifier`, use those as the table name     | database, schema, table, column |
| description  | Columns inherit the description from dbt, if one is provided in the dbt model/source yaml | column                          |
| sql\_dialect | Based on the adapter used for the dbt build                                               | table, column                   |

## Relationships

### Lineage (upstream/downstream)

We observe lineage between dbt models, snapshots and exposures and other dbt resources like seed, models, sources, based on dbt's native dependency identification.

We observe lineage between tables based on the compiled dbt SQL code

We observe column level lineage between table columns based on the compiled dbt SQL code generating each table

For warehouse table resources, field-level lineage (`upstream_fields`) may include statement-level SQL dependencies from the compiled query, not only projected columns. This means columns referenced in query logic (for example in `JOIN`, `WHERE`, `GROUP BY`, `HAVING`, `QUALIFY`, or `ORDER BY`) can appear as upstream field dependencies even when they are not selected into the final projection.

We observe lineage between dbt metrics and other dbt metrics, and column level lineage (upstream\_fields) dbt semantic models, measures and dimensions.

We observe lineage between dbt semantic models and their underlying dbt models.

### Parent / Child

All dbt models, snapshots, exposures, sources, seeds, metrics and semantic models are `child` of the dbt project resource.

Columns are observed twice: once as children of the dbt resource and once as children of the table containing them.

All dbt dimensions and measures are children of the dbt model on which they are defined.

### Defines

dbt models, snapshots, sources and seed have a `defines` relationship with the data warehouse tables they refer to.

Columns that are children of dbt models and sources are considered definers of the columns under the warehouse table.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.euno.ai/sources/transformation-etl/dbt-core/dbt-integration-discovered-resources.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
